

import userdb.*;
import java.sql.*;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;



class UnixUserHomeImpl extends UnixUserHomePOA
{
    ORB orb;
    POA userdbPOA;
    String dbUrl;
    String dbUser;
    String dbPassword;

    UnixUserHomeImpl(ORB orb, POA userdbPOA, String dbUrl,
			     String dbUser, String dbPassword)
    {
	this.orb = orb;
	this.userdbPOA = userdbPOA;
	this.dbUrl = dbUrl;
	this.dbUser = dbUser;
	this.dbPassword = dbPassword;
    }


    public UnixUser find_by_login(String login)
	throws UnixUserNotFound
    { 
	UnixUser user;

	for (int i=0; i < login.length(); i++)
	{
	    if (
	    "0123456789abcdefghijklmnopqrstuvwxyz".
		    indexOf( login.charAt(i) ) < 0)
	    {
		throw new UnixUserNotFound();
	    }
	}

	try
	{
	    Connection db =
		DriverManager.getConnection(dbUrl, dbUser, dbPassword);

            Statement stmt = db.createStatement();
	      
            ResultSet rs = stmt.executeQuery(
		 "SELECT sid FROM USERIDS WHERE login='" + login + "'");

	    if (!rs.next())
	    {
		throw new UnixUserNotFound();
	    }

	    user = UnixUserHelper.narrow(
		userdbPOA.create_reference_with_id(
		    rs.getString("sid").getBytes(),
				"IDL:userdb/UnixUser:1.0"));

	    rs.close();
	    stmt.close();
	    db.close();
	}
	catch (UnixUserNotFound nf)
	{
	    throw nf;
	}
	catch (Exception e)
	{
	    e.printStackTrace();

	    throw new org.omg.CORBA.UNKNOWN();
	}

	return user;
    }
}

