
import userdb.*;
import java.sql.*;

import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.CosTransactions.*;


class UnixUserServant extends UnixUserPOA
{
    ORB orb;
    POA userdbPOA;
    String dbUrl;
    String dbUser;
    String dbPassword;
    java.util.Vector resources;

    class State
    {
	String sid;
	String login;
	int    uid;
	int    gid;
	String name;
	String homedir;
	UnixUserStatus status;
    }

    State state;

    
    UnixUserServant (ORB orb, POA userdbPOA, String dbUrl,
	String dbUser, String dbPassword, State state)
    {
	this.orb = orb;
	this.userdbPOA = userdbPOA;
	this.dbUrl = dbUrl;
	this.dbUser = dbUser;
	this.dbPassword = dbPassword;
	this.state = state;
	resources = new java.util.Vector();
    }

    void checkState()
    {
	if (state == null)
	{
	    throw new org.omg.CORBA.UNKNOWN("state variable not set");
	}

        System.out.println(" accessing " + state.login);
    }

    public String sid() { checkState(); return state.sid; }
    public String login() { checkState(); return state.login; }
    public int uid() { checkState(); return state.uid; }
    public int gid() { checkState(); return state.gid; }
    public String name() { checkState(); return state.name; }
    public String homedir() { checkState(); return state.homedir; }

    public UnixUserStatus status()
    {
	checkState();

	UnixUserResourceImpl r = getResource();

	if (r == null)
	{
	    return state.status;
	}
	else
	{
	    return r.newStatus();
	}
    }



    public void status(UnixUserStatus s)
    {
	checkState();

	if (state.sid.startsWith("MQ"))
	{
	    UnixUserResourceImpl r = getResource();

	    if (r == null)
	    {
		throw new org.omg.CORBA.TRANSACTION_REQUIRED();
	    }

	    r.newStatus(s);

	}
	else
	{
	    System.out.println(" warning: status change for "+
		state.login + " not allowed..");

	    throw new org.omg.CORBA.NO_PERMISSION();
	}
    }

    void removeResource( UnixUserResourceImpl r )
    {
	resources.removeElement(r);
	try
	{
	    POA rootPOA = POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	    rootPOA.deactivate_object(rootPOA.servant_to_id(r));
	}
	catch (Exception e)
	{
	    e.printStackTrace();
	}
    }


    UnixUserResourceImpl getResource ()
    {
	UnixUserResourceImpl ur = null;

	try
	{
	    Current c = CurrentHelper.narrow(
		orb.resolve_initial_references("TransactionCurrent"));
	    Control ctrl = c.get_control();

	    if (ctrl == null)
	    {
		ur = null; // keine Transaktion
	    }
	    else
	    {
		Coordinator coord = ctrl.get_coordinator();
		
		for (int i=0; i < resources.size(); i++)
		{
		    UnixUserResourceImpl r = (UnixUserResourceImpl)
			resources.elementAt(i);

		    if (coord.is_same_transaction(r.coordinator()))
		    {
			ur = r;
			break;
		    }
		}
		
		if (ur == null)
		{
		    ur = new UnixUserResourceImpl(this, coord);
		}

		POA rootPOA = POAHelper.narrow(
		    orb.resolve_initial_references("RootPOA"));

		UnixUserResource res = UnixUserResourceHelper.narrow(
		    rootPOA.servant_to_reference(ur));

		try
		{
		    coord.register_resource(res);
		    resources.addElement(ur);
		}
		catch (org.omg.CORBA.TRANSACTION_ROLLEDBACK ex)
		{
		    rootPOA.deactivate_object(rootPOA.servant_to_id(ur));
		    throw ex;
		}
	    }
	}
	catch (org.omg.CORBA.TRANSACTION_ROLLEDBACK ex)
	{
	    throw ex;
	}
	catch (Exception e)
	{
	    e.printStackTrace();
	    ur = null;
	}

	return ur;
    }
}

