package userdb;

//
// Helper class for : ShortInfo
//
// @author OpenORB Compiler
//
public class ShortInfoHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert ShortInfo into an any
	// @param	a an any
	// @param	t ShortInfo value
	//
	public static void insert( org.omg.CORBA.Any a, userdb.ShortInfo t )
	{
		a.insert_Streamable( new userdb.ShortInfoHolder( t ));
	}

	//
	// Extract ShortInfo from an any
	// @param	a an any
	// @return the extracted ShortInfo value
	//
	public static userdb.ShortInfo extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof userdb.ShortInfoHolder)
					return ((userdb.ShortInfoHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			userdb.ShortInfoHolder h = new userdb.ShortInfoHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the ShortInfo TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "name";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "status";
				_members[1].type = userdb.UnixUserStatusHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "theUser";
				_members[2].type = userdb.UnixUserHelper.type();
				_tc = orb.create_struct_tc(id(),"ShortInfo",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the ShortInfo IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:userdb/ShortInfo:1.0";

	//
	// Read ShortInfo from a marshalled stream
	// @param	istream the input stream
	// @return the readed ShortInfo value
	//
	public static userdb.ShortInfo read( org.omg.CORBA.portable.InputStream istream )
	{
		userdb.ShortInfo new_one = new userdb.ShortInfo();

		new_one.name = istream.read_string();
		new_one.status = userdb.UnixUserStatusHelper.read(istream);
		new_one.theUser = userdb.UnixUserHelper.read(istream);

		return new_one;
	}

	//
	// Write ShortInfo into a marshalled stream
	// @param	ostream the output stream
	// @param	value ShortInfo value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, userdb.ShortInfo value )
	{
		ostream.write_string(value.name);
		userdb.UnixUserStatusHelper.write(ostream,value.status);
		userdb.UnixUserHelper.write(ostream,value.theUser);
	}

}
